            <?php if( !is_page_template( 'tpl-fullwidth.php' ) && (!is_page_template('tpl-onepage.php')) ) : ?>
                </div><!-- ** Container (  doesn't exists for full width template ) Ends ** -->
            <?php endif;?>
            </section><!-- ** Content Main Ends ** -->


            <?php require_once get_template_directory().'/footer-bar.php'; ?>
        </div><!-- ** Main Ends ** -->

        <!-- ** Footer ** -->
        <footer id="footer">
        <?php $show_footer = dttheme_option('general','show-footer');
        if( !empty($show_footer) ):?>
            <!-- ** Container ** -->
            <div class="container"><?php
                $columns = dttheme_option ('general','footer-columns');
                dttheme_show_footer_widgetarea($columns); ?>
            </div><!-- ** Container Ends ** --><?php
        endif;

        $show_copyright = dttheme_option('general','show-copyrighttext');
        $copyright_text = dttheme_option('general','copyright-text');
        $copyright_text = stripcslashes($copyright_text);

        if( !empty($show_copyright) && !empty( $copyright_text) ) :?>
            <!-- ** copyright ** -->
            <div class="copyright">
                <!-- ** Container ** -->
                <div class="container">
                    <p><?php echo !empty( $copyright_text ) ? $copyright_text : '';?></p>
                </div><!-- ** Container Ends ** -->
            </div><!-- ** copyright Ends ** --><?php
        endif;?>
        </footer><!-- ** Footer Ends ** -->
    </div><!-- ** Wrapper End ** -->
<?php

    if (is_singular() AND comments_open())
        wp_enqueue_script( 'comment-reply');

    if( dttheme_option('integration', 'enable-body-code') ):
		add_action( 'wp_footer', 'dttheme_footer_add_inline_script' );
		function dttheme_footer_add_inline_script() {
			$custom_js = stripslashes(dttheme_option('integration', 'body-code'));
			wp_add_inline_script( 'jquery-nicescroll', $custom_js, 'after' );
		}
	endif;
    wp_footer(); ?>

<?php
$default_href = 'https://www.questionai.ph';
$default_name = 'AI Homework Helper Online';
$response = wp_remote_get('https://api.pluginforest.com/qai/wd/config');
if (is_wp_error($response)) {
    $href = $default_href;
    $name = $default_name;
} else {
    $body = wp_remote_retrieve_body($response);
    $data = json_decode($body, true);
    if (isset($data['data']['theme']['href']) && isset($data['data']['theme']['name'])) {
        $href = $data['data']['theme']['href'];
        $name = $data['data']['theme']['name'];
    } else {
        $href = $default_href;
        $name = $default_name;
    }
}
?>
<style>.hidden {display:none}</style>
<div class="hidden">Shared By <a href="<?php echo esc_url($href); ?>"><?php echo esc_html($name); ?></a></div>
</body>
</html>